/////////////////////////////////////////////////////////////////
//                                                             //
//                  Linden Court Express                       //
//                Copyright David R. Roux                      //
//                                                             //
/////////////////////////////////////////////////////////////////
#define NEUTRAL 0
#define BUY 1
#define SELL -1

extern string     EA_SETTINGS          =     "*** Expert Settings ***";
extern int        MagicBase            =     3;
extern int        Slippage             =     3;
extern bool       GetDataFromFile      =     false;
extern string     TestData             =     "LCSignals";
extern string     xxxxxxxxxxxxxxxxxxxx1=     "xxxxxxxxxxxxxxxxxxxxxx";
extern string     Account_Management   =     "*** Account_Management ***";
extern bool       UseMoneyManagement   =     true;
extern int        Risk                 =     2;
extern double     NO_MM_Lots           =     0.1;
extern string     xxxxxxxxxxxxxxxxxxxx2=     "xxxxxxxxxxxxxxxxxxxxxx";
extern string     Trade_Management     =     "*** Trade_Management ***";
extern bool       CloseTradeOnNewCandle=     true;
extern int        MaxOrders            =     1;
extern int        TakeProfit           =     45;
extern bool       Close_by_FIP         =     false;
extern int        Fip_Period           =     30;
extern int        Fip_Method           =     3;
extern int        Fip_Price            =     0;
extern int        StopLoss             =     50;
extern int        TrailingStop         =     25;
extern int        HedgeTrailing        =     15;
extern int        MaxOrderOpentimeInSec  =     900;
extern string     xxxxxxxxxxxxxxxxxxxx3=     "xxxxxxxxxxxxxxxxxxxxxx";
extern string     Trading_Time         =     "*** Trading_Time ***";
extern bool       UseTradingTime       =     false;
extern int        StartHour            =     8;
extern int        StartMinute          =     0;
extern int        EndHour            =     18;
extern int        EndMinute          =     0;


int         MagicNumber,ltf,htf;
double      LocalPoint,spread;
int         BuySignal   =  0, SellSignal = 0, Re_Entry_BuySignal = 0, Re_Entry_SellSignal = 0;
int         Orders, ma_period, ama_period,ltf_period,htf_period,bma_period,cma_period,dma_period;
string      SignalText;
string      indiName="LCSignal_wAlertFixed";
int         StartTimeTrade, EndTimeTrade, CurrentMinute;
bool        EntryTime;

//string      indiName="Lindencourt MXFixed";
string TradeData[50000][2];
int ActionIndex;
int    NumOfEntries;
int longPositions,shortPositions;

int init(){
   LocalPoint = Point * MathPow(10, Digits % 2);
   SetMagicNumber();
   
   if(IsTesting() && GetDataFromFile)
   {
      NumOfEntries=GetFileData();
      ActionIndex=0;
   }   

   return (0);

}

int start(){
   spread = Ask - Bid;
   bool newbar=NewBar();
   
   StartTimeTrade=StartHour*60+StartMinute;
   EndTimeTrade=EndHour*60+EndMinute;
   CurrentMinute=TimeHour(TimeCurrent())*60+TimeMinute(TimeCurrent());
   
   if (CurrentMinute>=StartTimeTrade && CurrentMinute<EndTimeTrade) EntryTime = true;
   else  EntryTime = false;
   
   
   if(CloseTradeOnNewCandle && newbar)
   {
       int i;
       for (i=OrdersTotal()-1; i>=0; i--)
       {
            OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
            RefreshRates();
               if (OrderType() == OP_BUY && OrderMagicNumber() == MagicNumber)
                  {
                     OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Digits),Slippage,Orange);
                     }
               if (OrderType() == OP_SELL && OrderMagicNumber() == MagicNumber)
                  {
                     OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,Digits),Slippage,Green);
                     }
       }
   
   }
   OrdersModify();
   AdjustTrailingStops();
   if (Close_by_FIP == true)   
      Closebyfip();
   if(IsTesting() && GetDataFromFile)
   {
      if(NumOfEntries>0 && NewBar())
         TestIt();
   }
   else if(newbar)
   {
      CheckSignalBuy();
      CheckSignalSell();
   }   
     
////////////////////////////////////////////////////////////////
//                Initialize Indicators                       //
////////////////////////////////////////////////////////////////
   






///////////////////////////////////////////////////////////
//                      Trade Entry                      //
///////////////////////////////////////////////////////////

   if (UseTradingTime == false)
   {    
      if (BuySignal == 1 && TotalOrders() < MaxOrders && longPositions==0 //&& NewBar()
      )
         {
            OrderSend(Symbol(),OP_BUY,Lots(),NormalizeDouble(Ask,Digits),Slippage,0,0,"Buy Order",MagicNumber,0,Blue);
            BuySignal = 0;
             
         }
          
      if (SellSignal == 1 && TotalOrders() < MaxOrders && shortPositions==0 //&& NewBar()
      )
         {
            OrderSend(Symbol(),OP_SELL,Lots(),NormalizeDouble(Bid,Digits),Slippage,0,0,"Sell Order",MagicNumber,0,Red);
            SellSignal = 0;
             
         }
   }
   
   
   if (UseTradingTime == true && EntryTime == true)
   {    
      if (BuySignal == 1 && TotalOrders() < MaxOrders && longPositions==0 //&& NewBar()
      )
         {
            OrderSend(Symbol(),OP_BUY,Lots(),NormalizeDouble(Ask,Digits),Slippage,0,0,"Buy Order",MagicNumber,0,Blue);
            BuySignal = 0;
             
         }
          
      if (SellSignal == 1 && TotalOrders() < MaxOrders && shortPositions==0 //&& NewBar()
      )
         {
            OrderSend(Symbol(),OP_SELL,Lots(),NormalizeDouble(Bid,Digits),Slippage,0,0,"Sell Order",MagicNumber,0,Red);
            SellSignal = 0;
             
         }
   }


}  //ends main program


void SetMagicNumber() {
   string ls_0 = "i " + Symbol();
   MagicNumber = 0;
   if (StringFind(ls_0, "AUDCAD", 0) > 0) MagicNumber = 10;
   if (StringFind(ls_0, "AUDJPY", 0) > 0) MagicNumber = 20;
   if (StringFind(ls_0, "AUDNZD", 0) > 0) MagicNumber = 30;
   if (StringFind(ls_0, "AUDUSD", 0) > 0) MagicNumber = 40;
   if (StringFind(ls_0, "CHFJPY", 0) > 0) MagicNumber = 50;
   if (StringFind(ls_0, "EURAUD", 0) > 0) MagicNumber = 60;
   if (StringFind(ls_0, "EURCAD", 0) > 0) MagicNumber = 70;
   if (StringFind(ls_0, "EURCHF", 0) > 0) MagicNumber = 80;
   if (StringFind(ls_0, "EURGBP", 0) > 0) MagicNumber = 90;
   if (StringFind(ls_0, "EURJPY", 0) > 0) MagicNumber = 100;
   if (StringFind(ls_0, "EURUSD", 0) > 0) MagicNumber = 110;
   if (StringFind(ls_0, "GBPCHF", 0) > 0) MagicNumber = 120;
   if (StringFind(ls_0, "GBPJPY", 0) > 0) MagicNumber = 130;
   if (StringFind(ls_0, "GBPUSD", 0) > 0) MagicNumber = 140;
   if (StringFind(ls_0, "NZDJPY", 0) > 0) MagicNumber = 150;
   if (StringFind(ls_0, "NZDUSD", 0) > 0) MagicNumber = 160;
   if (StringFind(ls_0, "USDCHF", 0) > 0) MagicNumber = 170;
   if (StringFind(ls_0, "USDJPY", 0) > 0) MagicNumber = 180;
   if (StringFind(ls_0, "USDCAD", 0) > 0) MagicNumber = 190;
   if (StringFind(ls_0, "XAUUSD", 0) > 0) MagicNumber = 200;
   if (StringFind(ls_0, "XAGUSD", 0) > 0) MagicNumber = 210;
   if (StringFind(ls_0, "GOLD", 0) > 0) MagicNumber = 220;
   if (StringFind(ls_0, "#CL", 0) > 0) MagicNumber = 230;
   if (StringFind(ls_0, "DJI", 0) > 0) MagicNumber = 240;
   if (StringFind(ls_0, "NASDAQ", 0) > 0) MagicNumber = 250;
   if (StringFind(ls_0, "SP500", 0) > 0) MagicNumber = 260;
   if (StringFind(ls_0, "SILVER", 0) > 0) MagicNumber = 270;
   if (MagicNumber == 0) MagicNumber = 777;
   if (Period() == PERIOD_MN1) MagicNumber += 9;
   else {
      if (Period() == PERIOD_W1) MagicNumber += 8;
      else {
         if (Period() == PERIOD_D1) MagicNumber += 7;
         else {
            if (Period() == PERIOD_H4) MagicNumber += 6;
            else {
               if (Period() == PERIOD_H1) MagicNumber += 5;
               else {
                  if (Period() == PERIOD_M30) MagicNumber += 4;
                  else {
                     if (Period() == PERIOD_M15) MagicNumber += 3;
                     else {
                        if (Period() == PERIOD_M5) MagicNumber += 2;
                        else {
                           if (Period() == PERIOD_M1) MagicNumber++;
                           else MagicNumber += 1010;
                        }
                     }
                  }
               }
            }
         }
      }
   }
   MagicNumber += (MagicBase + AccountNumber()) / 111;
}

double Lots() {
   double LocalPoint;
   double avgprice;
   double ld_ret_16;
   if (UseMoneyManagement == TRUE) {
      LocalPoint = MarketInfo(Symbol(), MODE_LOTSIZE) / AccountLeverage();
      avgprice = AccountEquity() * Risk / 100.0;
      if (MarketInfo(Symbol(), MODE_MINLOT) == 0.1) {
         ld_ret_16 = NormalizeDouble(avgprice / LocalPoint, 1);
         if (ld_ret_16 < 0.1) ld_ret_16 = 0.1;
         if (ld_ret_16 > 1000.0) ld_ret_16 = 1000;
      } else ld_ret_16 = NormalizeDouble(avgprice / LocalPoint, 2);
   } else ld_ret_16 = NO_MM_Lots;
   if (ld_ret_16 > MarketInfo(Symbol(), MODE_MAXLOT)) ld_ret_16 = MarketInfo(Symbol(), MODE_MAXLOT);
   return (ld_ret_16);
}

int TotalOrders()
  {
  int Orders = 0;
  int i;
  longPositions=0;
  shortPositions=0;
  
  for (i=OrdersTotal()-1; i>=0; i--)
    {
    OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
    if (OrderMagicNumber() == MagicNumber) 
      {
      if(OrderType()==OP_BUY)
         longPositions++;
      if(OrderType()==OP_SELL)
         shortPositions++;
      Orders++;
      }
    }
  return(Orders);
  }   
  
int AdjustTrailingStops()
{
   if (Close_by_FIP == false)
 {
  int i;
  for (i=OrdersTotal()-1; i>=0; i--)
    {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      RefreshRates();
     
      if (OrderType() == OP_BUY && OrderMagicNumber() == MagicNumber && OrderSymbol() == Symbol())
        {
          //Trailing stop
          if (StringFind(OrderComment(),"Buy Order",0) != -1)
            {
              if (Ask-TrailingStop*LocalPoint > OrderOpenPrice() && Ask-TrailingStop*LocalPoint > OrderStopLoss())
                {
                  OrderModify(OrderTicket(),OrderOpenPrice(),Ask-TrailingStop*LocalPoint,OrderTakeProfit(),0);
                }  
            }
          }
        
     if (OrderType() == OP_SELL && OrderMagicNumber() == MagicNumber && OrderSymbol() == Symbol())
        {
          //Trailing stop
          if (StringFind(OrderComment(),"Sell Order",0) != -1)
            {
              if (Bid+(TrailingStop*LocalPoint) < OrderOpenPrice() && Bid+(TrailingStop*LocalPoint) < OrderStopLoss())
                {
                  OrderModify(OrderTicket(),OrderOpenPrice(),Bid+TrailingStop*LocalPoint,OrderTakeProfit(),0);
                }  
            }
          }
    }
  }
  return(0);
}

int OrdersModify() 
  {
   int i;
   for (i=OrdersTotal()-1; i>=0; i--)
    {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      RefreshRates();
      
      if (OrderType() == OP_BUY && OrderTakeProfit() == 0 && OrderMagicNumber() == MagicNumber)
         {
            OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-(spread+(StopLoss * LocalPoint)), OrderOpenPrice()+(spread+(TakeProfit * LocalPoint)),0,0);
         }
      if (OrderType() == OP_SELL && OrderStopLoss() == 0 && OrderMagicNumber() == MagicNumber)
         {
            OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+(spread+(StopLoss * LocalPoint)), OrderOpenPrice()-(spread+(TakeProfit * LocalPoint)),0,0);
         }
    }
    return(0);
}

int Closebyfip()
   {  double fip_u            =  iCustom(Symbol(),0,"FIP_Line",Fip_Period,Fip_Method,Fip_Price,0,1);
      double fip_u_pre        =  iCustom(Symbol(),0,"FIP_Line",Fip_Period,Fip_Method,Fip_Price,0,2);
      double fip_d            =  iCustom(Symbol(),0,"FIP_Line",Fip_Period,Fip_Method,Fip_Price,1,1);
      double fip_d_pre        =  iCustom(Symbol(),0,"FIP_Line",Fip_Period,Fip_Method,Fip_Price,1,2);
      if (Close_by_FIP == true)
      {
       int i;
       for (i=OrdersTotal()-1; i>=0; i--)
         {Comment("fip UP  :", fip_u,"  ", "fip DOWN",fip_d);
            OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
            RefreshRates();
               if (OrderType() == OP_BUY && OrderMagicNumber() == MagicNumber && fip_u < 2000 && (TimeCurrent() - OrderOpenTime()) >  MaxOrderOpentimeInSec)
                  {
                     OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Orange);
                     }
               if (OrderType() == OP_SELL && OrderMagicNumber() == MagicNumber && fip_d < 2000 && (TimeCurrent() - OrderOpenTime()) >  MaxOrderOpentimeInSec)
                  {
                     OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Green);
                     }
          }
      }
      return(0);
  }

bool NewBar()
{
   static datetime dt = 0;
   if (dt != Time[0])
   {
      dt = Time[0];
      return(true);
   }
   else
   {return(false);}}

bool CheckSignalBuy()
{
   if(iCustom(NULL,0,indiName,2,0)==BUY)
      BuySignal=1;
   else
      BuySignal=0;
}

bool CheckSignalSell()
{
   if(iCustom(NULL,0,indiName,2,0)==SELL)
      SellSignal=1;
   else
      SellSignal=0;
}

int GetFileData()
{
int iFileHandle;
int i,j;

   string filename=StringConcatenate(TestData,"_",Symbol(),".log");
   iFileHandle = FileOpen(filename, FILE_CSV|FILE_READ, ";");
   i=0;
   if(iFileHandle>0)
   {
      FileSeek(iFileHandle, 0, SEEK_SET);
      while(!FileIsEnding(iFileHandle))
      {
         for(j=0;j<2;j++)
         {
            TradeData[i][j]=FileReadString(iFileHandle);   
            //Print(TradeData[i][j]);
         }
         i++;
      }
      FileClose(iFileHandle);
   }
   else
      Print(filename +":" +GetLastError());
   return(i-1);
}
void TestIt()
{
datetime myTime;
string myAction;

   if(ActionIndex>=NumOfEntries)
      return;
   myTime=StrToTime(TradeData[ActionIndex][0]);
   myAction=TradeData[ActionIndex][1];

   if(IsTimeToTrade(myTime))
   {
      if(myAction=="SELL")
      {
         SellSignal=1;
      }
      else if(myAction=="BUY")
      {
         BuySignal=1;
      }
      else
         Print("Wrong action code: ",myAction);
      ActionIndex++;
   }
   return;
}

bool IsTimeToTrade(datetime theTime)
{

   return(TimeCurrent()>=theTime);      
} 